=== added directory 'HandlerSocket-Plugin-for-MySQL/m4'
=== modified file 'Makefile'
--- Makefile	2010-12-17 19:06:49 +0000
+++ Makefile	2010-12-20 21:54:44 +0000
@@ -3,7 +3,7 @@
 MYSQL_VERSION=5.1.54
 PERCONA_SERVER ?=Percona-Server
 
-all: main install-lic tests misc handlersocket autorun
+all: main install-lic tests misc handlersocket maatkit-udf autorun
 	@echo ""
 	@echo "Percona Server source code is ready"
 	@echo "Now change directory to $(PERCONA_SERVER) define variables as show below"
@@ -20,6 +20,11 @@
 
 handlersocket:
 	cp -R HandlerSocket-Plugin-for-MySQL $(PERCONA_SERVER)/storage
+	patch -p0 -d $(PERCONA_SERVER)/storage/HandlerSocket-Plugin-for-MySQL < handlersocket.patch
+
+maatkit-udf:
+	cp -R UDF "$(PERCONA_SERVER)"
+	cd "$(PERCONA_SERVER)"/UDF && autoreconf --install
 
 install-lic: 
 	@echo "Installing license files"

=== added directory 'UDF'
=== added file 'UDF/Makefile.am'
--- UDF/Makefile.am	1970-01-01 00:00:00 +0000
+++ UDF/Makefile.am	2010-12-17 15:26:10 +0000
@@ -0,0 +1,1 @@
+SUBDIRS = src

=== added file 'UDF/configure.ac'
--- UDF/configure.ac	1970-01-01 00:00:00 +0000
+++ UDF/configure.ac	2010-12-17 15:26:10 +0000
@@ -0,0 +1,10 @@
+AC_INIT([maatkit-udf], [0.1], [http://code.google.com/p/maatkit/issues/list])
+AM_INIT_AUTOMAKE([foreign -Wall -Werror])
+LT INIT
+AC_PROG_LIBTOOL
+AC_PROG_CC
+AC_PROG_CXX
+AC_PROG_RANLIB
+AC_CONFIG_HEADERS([config.h])
+AC_CONFIG_FILES([Makefile src/Makefile])
+AC_OUTPUT

=== added directory 'UDF/src'
=== added file 'UDF/src/Makefile.am'
--- UDF/src/Makefile.am	1970-01-01 00:00:00 +0000
+++ UDF/src/Makefile.am	2010-12-17 15:26:10 +0000
@@ -0,0 +1,7 @@
+lib_LTLIBRARIES = libfnv1a_udf.la libfnv_udf.la libmurmur_udf.la
+libfnv1a_udf_la_SOURCES = fnv1a_udf.cc
+libfnv_udf_la_SOURCES = fnv_udf.cc
+libmurmur_udf_la_SOURCES = murmur_udf.cc
+libfnv1a_udf_la_CPPFLAGS = -I$(includedir)
+libfnv_udf_la_CPPFLAGS = -I$(includedir)
+libmurmur_udf_la_CPPFLAGS = -I$(includedir)

=== added file 'UDF/src/fnv1a_udf.cc'
--- UDF/src/fnv1a_udf.cc	1970-01-01 00:00:00 +0000
+++ UDF/src/fnv1a_udf.cc	2010-12-17 15:26:10 +0000
@@ -0,0 +1,202 @@
+/* This file implements a 64-bit FNV-1a hash UDF (user-defined function) for
+ * MySQL.  The function accepts any number of arguments and returns a 64-bit
+ * unsigned integer.  MySQL actually interprets the result as a signed integer,
+ * but you should ignore that.  I chose not to return the number as a
+ * hexadecimal string because using an integer makes it possible to use it
+ * efficiently with BIT_XOR().
+ *
+ * The function never returns NULL, even when you give it NULL arguments.
+ *
+ * To compile and install, execute the following commands.  The function name
+ * fnv1a_64 in the mysql command is case-sensitive!  (Of course, when you
+ * actually call the function, it is case-insensitive just like any other SQL
+ * function).
+ *
+ * gcc -fPIC -Wall -I/usr/include/mysql -shared -o fnv1a_udf.so fnv1a_udf.cc
+ * cp fnv1a_udf.so /lib * OR: * cp fnv1a_udf.so /usr/lib
+ * mysql mysql -e "CREATE FUNCTION fnv1a_64 RETURNS INTEGER SONAME 'fnv1a_udf.so'"
+ *
+ * For MySQL version 4.1 or older you must add the following flag to the gcc
+ * command above: -DNO_DECIMAL_RESULT
+ * Otherwise you will get an error like:
+ *   fnv1a_udf.cc:167: `DECIMAL_RESULT' undeclared (first use this function)
+ * (See http://code.google.com/p/maatkit/issues/detail?id=89)
+ * 
+ * If you get the error "ERROR 1126 (HY000): Can't open shared library
+ * 'fnv1a_udf.so' (errno: 22 fnv1a_udf.so: cannot open shared object file: No
+ * such file or directory)" then you may need to copy the .so file to another
+ * location in your system.  Look at your environment's $LD_LIBRARY_PATH
+ * variable for clues.  If none is set, you may need to set this variable to
+ * something like /lib.
+ *
+ * If you get the error "ERROR 1126 (HY000): Can't open shared library
+ * 'libfnv1a_udf.so' (errno: 22 /lib/libfnv1a_udf.so: undefined symbol: 
+ * __gxx_personality_v0)" then you may need to use g++ instead of gcc.
+ *
+ * Try both /lib and /usr/lib before changing LD_LIBRARY_PATH.
+ *
+ * On Mac OSX, use -dynamiclib instead of -shared and add -lstdc++ to the
+ * compile flags.
+ *
+ * Once installed successfully, you should be able to call the function.  Here's
+ * a faster alternative to MD5 hashing, with the added ability to hash multiple
+ * arguments in a single call:
+ *
+ * mysql> SELECT FNV1A_64('hello', 'world');
+ *
+ * Here's a way to reduce an entire table to a single order-independent hash:
+ *
+ * mysql> SELECT BIT_XOR(CAST(FNV1A_64(col1, col2, col3) AS UNSIGNED)) FROM tbl;
+ *
+ */
+
+/* The following header is from hash_64a.c:
+ *
+ * hash_64 - 64 bit Fowler/Noll/Vo-0 FNV-1a hash code
+ *
+ * @(#) $Revision: 5.1 $
+ * @(#) $Id: hash_64a.c,v 5.1 2009/06/30 09:01:38 chongo Exp $
+ * @(#) $Source: /usr/local/src/cmd/fnv/RCS/hash_64a.c,v $
+ *
+ ***
+ *
+ * Fowler/Noll/Vo hash
+ *
+ * The basis of this hash algorithm was taken from an idea sent
+ * as reviewer comments to the IEEE POSIX P1003.2 committee by:
+ *
+ *      Phong Vo (http://www.research.att.com/info/kpv/)
+ *      Glenn Fowler (http://www.research.att.com/~gsf/)
+ *
+ * In a subsequent ballot round:
+ *
+ *      Landon Curt Noll (http://www.isthe.com/chongo/)
+ *
+ * improved on their algorithm.  Some people tried this hash
+ * and found that it worked rather well.  In an EMail message
+ * to Landon, they named it the ``Fowler/Noll/Vo'' or FNV hash.
+ *
+ * FNV hashes are designed to be fast while maintaining a low
+ * collision rate. The FNV speed allows one to quickly hash lots
+ * of data while maintaining a reasonable collision rate.  See:
+ *
+ *      http://www.isthe.com/chongo/tech/comp/fnv/index.html
+ *
+ * for more details as well as other forms of the FNV hash.
+ *
+ ***
+ *
+ * To use the recommended 64 bit FNV-1a hash, pass FNV1A_64_INIT as the
+ * Fnv64_t hashval argument to fnv_64a_buf() or fnv_64a_str().
+ *
+ ***
+ *
+ * Please do not copyright this code.  This code is in the public domain.
+ *
+ * LANDON CURT NOLL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
+ * EVENT SHALL LANDON CURT NOLL BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
+ * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
+ * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ *
+ * By:
+ *	chongo <Landon Curt Noll> /\oo/\
+ *      http://www.isthe.com/chongo/
+ *
+ * Share and Enjoy!	:-)
+ */
+
+#include <my_global.h>
+#include <my_sys.h>
+#include <mysql.h>
+#include <ctype.h>
+#include <string.h>
+
+/* On the first call, use this as the initial_value. */
+#define FNV1A_64_INIT 0xcbf29ce484222325ULL
+/* Default for NULLs, just so the result is never NULL. */
+#define HASH_NULL_DEFAULT 0x0a0b0c0d
+/* Magic number for the hashing. */
+#define FNV_64_PRIME 0x100000001b3ULL
+
+/* Prototypes */
+
+extern "C" {
+   ulonglong hash64a(const void *buf, size_t len, ulonglong hval);
+   my_bool fnv1a_64_init(UDF_INIT* initid, UDF_ARGS* args, char* message);
+   ulonglong fnv1a_64(UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error );
+}
+
+/* Implementations */
+
+ulonglong hash64a(const void *buf, size_t len, ulonglong hval) {
+   const unsigned char *bp = (const unsigned char*)buf;
+   const unsigned char *be = bp + len;
+
+   /* FNV-1a hash each octet of the buffer */
+   for (; bp != be; ++bp) {
+      /* xor the bottom with the current octet */
+      hval ^= (ulonglong)*bp;
+      /* multiply by the 64 bit FNV magic prime mod 2^64 */
+      hval *= FNV_64_PRIME;
+   }
+
+   return hval;
+}
+
+my_bool
+fnv1a_64_init(UDF_INIT* initid, UDF_ARGS* args, char* message) {
+   if (args->arg_count == 0 ) {
+      strcpy(message,"FNV1A_64 requires at least one argument");
+      return 1;
+   }
+   initid->maybe_null = 0;      /* The result will never be NULL */
+   return 0;
+}
+
+ulonglong
+fnv1a_64(UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error) {
+
+   uint null_default = HASH_NULL_DEFAULT;
+   ulonglong result  = FNV1A_64_INIT;
+   uint i;
+
+   for (i = 0 ; i < args->arg_count; ++i ) {
+      if ( args->args[i] != NULL ) {
+         switch ( args->arg_type[i] ) {
+         case STRING_RESULT:
+         #ifdef NO_DECIMAL_RESULT
+         #else
+         case DECIMAL_RESULT:
+         #endif
+            result
+               = hash64a((const void*) args->args[i], args->lengths[i], result);
+            break;
+         case REAL_RESULT:
+            {
+               double real_val;
+               real_val = *((double*) args->args[i]);
+               result
+                  = hash64a((const void*)&real_val, sizeof(double), result);
+            }
+            break;
+         case INT_RESULT:
+            {
+               long long int_val;
+               int_val = *((long long*) args->args[i]);
+               result = hash64a((const void*)&int_val, sizeof(ulonglong), result);
+            }
+            break;
+         default:
+            break;
+         }
+      }
+      else {
+         result
+            = hash64a((const void*)&null_default, sizeof(null_default), result);
+      }
+   }
+   return result;
+}

=== added file 'UDF/src/fnv_udf.cc'
--- UDF/src/fnv_udf.cc	1970-01-01 00:00:00 +0000
+++ UDF/src/fnv_udf.cc	2010-12-17 15:26:10 +0000
@@ -0,0 +1,207 @@
+/* This file implements a 64-bit FNV-1 hash UDF (user-defined function) for
+ * MySQL.  The function accepts any number of arguments and returns a 64-bit
+ * unsigned integer.  MySQL actually interprets the result as a signed integer,
+ * but you should ignore that.  I chose not to return the number as a
+ * hexadecimal string because using an integer makes it possible to use it
+ * efficiently with BIT_XOR().
+ *
+ * The function never returns NULL, even when you give it NULL arguments.
+ *
+ * To compile and install, execute the following commands.  The function name
+ * fnv_64 in the mysql command is case-sensitive!  (Of course, when you actually
+ * call the function, it is case-insensitive just like any other SQL function).
+ *
+ * gcc -fPIC -Wall -I/usr/include/mysql -shared -o fnv_udf.so fnv_udf.cc
+ * cp fnv_udf.so /lib * OR: * cp fnv_udf.so /usr/lib
+ * mysql mysql -e "CREATE FUNCTION fnv_64 RETURNS INTEGER SONAME 'fnv_udf.so'"
+ *
+ * For MySQL version 4.1 or older you must add the following flag to the gcc
+ * command above: -DNO_DECIMAL_RESULT
+ * Otherwise you will get an error like:
+ *   fnv_udf.cc:167: `DECIMAL_RESULT' undeclared (first use this function)
+ * (See http://code.google.com/p/maatkit/issues/detail?id=89)
+ * 
+ * If you get the error "ERROR 1126 (HY000): Can't open shared library
+ * 'fnv_udf.so' (errno: 22 fnv_udf.so: cannot open shared object file: No such
+ * file or directory)" then you may need to copy the .so file to another
+ * location in your system.  Look at your environment's $LD_LIBRARY_PATH
+ * variable for clues.  If none is set, you may need to set this variable to
+ * something like /lib.
+ *
+ * If you get the error "ERROR 1126 (HY000): Can't open shared library
+ * 'libfnv_udf.so' (errno: 22 /lib/libfnv_udf.so: undefined symbol: 
+ * __gxx_personality_v0)" then you may need to use g++ instead of gcc.
+ *
+ * Try both /lib and /usr/lib before changing LD_LIBRARY_PATH.
+ *
+ * On Mac OSX, use -dynamiclib instead of -shared and add -lstdc++ to the
+ * compile flags.
+ *
+ * Once installed successfully, you should be able to call the function.  Here's
+ * a faster alternative to MD5 hashing, with the added ability to hash multiple
+ * arguments in a single call:
+ *
+ * mysql> SELECT FNV_64('hello', 'world');
+ *
+ * Here's a way to reduce an entire table to a single order-independent hash:
+ *
+ * mysql> SELECT BIT_XOR(CAST(FNV_64(col1, col2, col3) AS UNSIGNED)) FROM tbl1;
+ *
+ */
+
+/* The following header is from hash_64.c:
+ *
+ * hash_64 - 64 bit Fowler/Noll/Vo-0 hash code
+ *
+ * @(#) $Revision: 1.8 $
+ * @(#) $Id: hash_64.c,v 1.8 2003/10/03 20:37:04 chongo Exp $
+ * @(#) $Source: /usr/local/src/cmd/fnv/RCS/hash_64.c,v $
+ *
+ ***
+ *
+ * Fowler/Noll/Vo hash
+ *
+ * The basis of this hash algorithm was taken from an idea sent
+ * as reviewer comments to the IEEE POSIX P1003.2 committee by:
+ *
+ *      Phong Vo (http://www.research.att.com/info/kpv/)
+ *      Glenn Fowler (http://www.research.att.com/~gsf/)
+ *
+ * In a subsequent ballot round:
+ *
+ *      Landon Curt Noll (http://www.isthe.com/chongo/)
+ *
+ * improved on their algorithm.  Some people tried this hash
+ * and found that it worked rather well.  In an EMail message
+ * to Landon, they named it the ``Fowler/Noll/Vo'' or FNV hash.
+ *
+ * FNV hashes are designed to be fast while maintaining a low
+ * collision rate. The FNV speed allows one to quickly hash lots
+ * of data while maintaining a reasonable collision rate.  See:
+ *
+ *      http://www.isthe.com/chongo/tech/comp/fnv/index.html
+ *
+ * for more details as well as other forms of the FNV hash.
+ *
+ ***
+ *
+ * NOTE: The FNV-0 historic hash is not recommended.  One should use
+ *	 the FNV-1 hash instead.
+ *
+ * To use the 64 bit FNV-0 historic hash, pass FNV0_64_INIT as the
+ * Fnv64_t hashval argument to fnv_64_buf() or fnv_64_str().
+ *
+ * To use the recommended 64 bit FNV-1 hash, pass FNV1_64_INIT as the
+ * Fnv64_t hashval argument to fnv_64_buf() or fnv_64_str().
+ *
+ ***
+ *
+ * Please do not copyright this code.  This code is in the public domain.
+ *
+ * LANDON CURT NOLL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO
+ * EVENT SHALL LANDON CURT NOLL BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
+ * USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
+ * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ *
+ * By:
+ *	chongo <Landon Curt Noll> /\oo/\
+ *      http://www.isthe.com/chongo/
+ *
+ * Share and Enjoy!	:-)
+ */
+
+#include <my_global.h>
+#include <my_sys.h>
+#include <mysql.h>
+#include <ctype.h>
+#include <string.h>
+
+/* On the first call, use this as the initial_value. */
+#define HASH_64_INIT 0x84222325cbf29ce4ULL
+/* Default for NULLs, just so the result is never NULL. */
+#define HASH_NULL_DEFAULT 0x0a0b0c0d
+/* Magic number for the hashing. */
+#define FNV_64_PRIME 0x100000001b3ULL
+
+/* Prototypes */
+
+extern "C" {
+   ulonglong hash64(const void *buf, size_t len, ulonglong hval);
+   my_bool fnv_64_init( UDF_INIT* initid, UDF_ARGS* args, char* message );
+   ulonglong fnv_64(UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error );
+}
+
+/* Implementations */
+
+ulonglong hash64(const void *buf, size_t len, ulonglong hval) {
+   const unsigned char *bp = (const unsigned char*)buf;
+   const unsigned char *be = bp + len;
+
+   /* FNV-1 hash each octet of the buffer */
+   for (; bp != be; ++bp) {
+      /* multiply by the 64 bit FNV magic prime mod 2^64 */
+      hval *= FNV_64_PRIME;
+      /* xor the bottom with the current octet */
+      hval ^= (ulonglong)*bp;
+   }
+
+   return hval;
+}
+
+my_bool
+fnv_64_init( UDF_INIT* initid, UDF_ARGS* args, char* message ) {
+   if (args->arg_count == 0 ) {
+      strcpy(message,"FNV_64 requires at least one argument");
+      return 1;
+   }
+   initid->maybe_null = 0;      /* The result will never be NULL */
+   return 0;
+}
+
+ulonglong
+fnv_64(UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error ) {
+
+   uint null_default = HASH_NULL_DEFAULT;
+   ulonglong result  = HASH_64_INIT;
+   uint i;
+
+   for (i = 0 ; i < args->arg_count; ++i ) {
+      if ( args->args[i] != NULL ) {
+         switch ( args->arg_type[i] ) {
+         case STRING_RESULT:
+         #ifdef NO_DECIMAL_RESULT
+         #else
+         case DECIMAL_RESULT:
+         #endif
+            result
+               = hash64((const void*) args->args[i], args->lengths[i], result);
+            break;
+         case REAL_RESULT:
+            {
+               double real_val;
+               real_val = *((double*) args->args[i]);
+               result
+                  = hash64((const void*)&real_val, sizeof(double), result);
+            }
+            break;
+         case INT_RESULT:
+            {
+               long long int_val;
+               int_val = *((long long*) args->args[i]);
+               result = hash64((const void*)&int_val, sizeof(ulonglong), result);
+            }
+            break;
+         default:
+            break;
+         }
+      }
+      else {
+         result
+            = hash64((const void*)&null_default, sizeof(null_default), result);
+      }
+   }
+   return result;
+}

=== added file 'UDF/src/murmur_udf.cc'
--- UDF/src/murmur_udf.cc	1970-01-01 00:00:00 +0000
+++ UDF/src/murmur_udf.cc	2010-12-17 15:26:10 +0000
@@ -0,0 +1,166 @@
+/* License: This code is in the public domain.
+ *
+ * See http://murmurhash.googlepages.com/ for more about the Murmur hash.  The
+ * Murmur hash is by Austin Appleby.
+ *
+ * This file implements a 64-bit Murmur-2 hash UDF (user-defined function) for
+ * MySQL.  The function accepts any number of arguments and returns a 64-bit
+ * unsigned integer.  MySQL actually interprets the result as a signed integer,
+ * but you should ignore that.  I chose not to return the number as a
+ * hexadecimal string because using an integer makes it possible to use it
+ * efficiently with BIT_XOR().
+ *
+ * The function never returns NULL, even when you give it NULL arguments.
+ *
+ * To compile and install, execute the following commands.  The function name
+ * murmur_hash in the mysql command is case-sensitive!  (Of course, when you
+ * actually call the function, it is case-insensitive just like any other SQL
+ * function).
+ *
+ * g++ -fPIC -Wall -I/usr/include/mysql -shared -o murmur_udf.so murmur_udf.cc
+ * cp murmur_udf.so /lib
+ * mysql mysql -e "CREATE FUNCTION murmur_hash RETURNS INTEGER SONAME 'murmur_udf.so'"
+ *
+ * Once installed successfully, you should be able to call the function.  Here's
+ * a faster alternative to MD5 hashing, with the added ability to hash multiple
+ * arguments in a single call:
+ *
+ * mysql> SELECT MURMUR_HASH('hello', 'world');
+ *
+ * Here's a way to reduce an entire table to a single order-independent hash:
+ *
+ * mysql> SELECT BIT_XOR(CAST(MURMUR_HASH(col1, col2, col3) AS UNSIGNED)) FROM tbl1;
+ *
+ * Note - This code makes a few assumptions about how your machine behaves -
+ * 1. We can read a 4-byte value from any address without crashing
+ * 2. sizeof(int) == 4
+ *
+ * And it has a few limitations:
+ * 1. It will not work incrementally.
+ * 2. It will not produce the same results on little-endian and big-endian machines.
+ */
+
+#include <my_global.h>
+#include <my_sys.h>
+#include <mysql.h>
+#include <ctype.h>
+#include <string.h>
+
+/* On the first call, use this as the initial_value. */
+#define HASH_64_INIT 0x84222325cbf29ce4ULL
+/* Default for NULLs, just so the result is never NULL. */
+#define HASH_NULL_DEFAULT 0x0a0b0c0d
+
+/* Prototypes */
+
+extern "C" {
+   ulonglong MurmurHash2( const void *key, int len, unsigned int seed );
+   my_bool murmur_hash_init( UDF_INIT* initid, UDF_ARGS* args, char* message );
+   ulonglong murmur_hash( UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error );
+}
+
+/* Implementations */
+
+/*
+ * MurmurHash2, by Austin Appleby
+ * This is the 64 bit version of MurmurHash2 for 32-bit platforms.
+ */
+
+ulonglong
+MurmurHash2( const void *key, int len, unsigned int seed ) {
+
+   const unsigned int m = 0x5bd1e995;
+   const int r = 24;
+
+   unsigned int h1 = seed ^ len;
+   unsigned int h2 = 0;
+
+   const unsigned int *data = (const unsigned int *)key;
+
+   while (len >= 8) {
+      unsigned int k1 = *data++;
+      k1 *= m; k1 ^= k1 >> r; k1 *= m;
+      h1 *= m; h1 ^= k1;
+      len -= 4;
+
+      unsigned int k2 = *data++;
+      k2 *= m; k2 ^= k2 >> r; k2 *= m;
+      h2 *= m; h2 ^= k2;
+      len -= 4;
+   }
+
+   if (len >= 4) {
+      unsigned int k1 = *data++;
+      k1 *= m; k1 ^= k1 >> r; k1 *= m;
+      h1 *= m; h1 ^= k1;
+      len -= 4;
+   }
+
+   switch (len) {
+      case 3: h2 ^= ((unsigned char*)data)[2] << 16;
+      case 2: h2 ^= ((unsigned char*)data)[1] << 8;
+      case 1: h2 ^= ((unsigned char*)data)[0];
+              h2 *= m;
+   };
+
+   h1 ^= h2 >> 18; h1 *= m;
+   h2 ^= h1 >> 22; h2 *= m;
+   h1 ^= h2 >> 17; h1 *= m;
+
+   ulonglong h = h1;
+
+   h = (h << 32) | h2;
+   return h;
+}
+
+my_bool 
+murmur_hash_init( UDF_INIT* initid, UDF_ARGS* args, char* message) {
+   if (args->arg_count == 0 ) {
+      strcpy(message,"MURMUR_HASH requires at least one argument");
+      return 1;
+   }
+   initid->maybe_null = 0;      /* The result will never be NULL */
+   return 0;
+}
+
+ulonglong 
+murmur_hash( UDF_INIT *initid, UDF_ARGS *args, char *is_null, char *error ) {
+
+   uint null_default = HASH_NULL_DEFAULT;
+   ulonglong result  = HASH_64_INIT;
+   uint i;
+
+   for (i = 0 ; i < args->arg_count; ++i ) {
+      if ( args->args[i] != NULL ) {
+         switch ( args->arg_type[i] ) {
+         case STRING_RESULT:
+         case DECIMAL_RESULT:
+            result
+               = MurmurHash2((const void*) args->args[i], args->lengths[i], result);
+            break;
+         case REAL_RESULT:
+            {
+               double real_val;
+               real_val = *((double*) args->args[i]);
+               result
+                  = MurmurHash2((const void*)&real_val, sizeof(double), result);
+            }
+            break;
+         case INT_RESULT:
+            {
+               long long int_val;
+               int_val = *((long long*) args->args[i]);
+               result = MurmurHash2((const void*)&int_val, sizeof(ulonglong), result);
+            }
+            break;
+         default:
+            break;
+         }
+      }
+      else {
+         result
+            = MurmurHash2((const void*)&null_default, sizeof(null_default), result);
+      }
+   }
+   return result;
+}

=== modified file 'build/debian/control'
--- build/debian/control	2010-11-26 23:38:34 +0000
+++ build/debian/control	2010-12-20 21:54:44 +0000
@@ -5,9 +5,9 @@
 Uploaders: Aleksandr Kuzminsky <aleksandr.kuzminsky@percona.com>
 Build-Depends: libtool (>= 1.4.2-7), procps | hurd,  debhelper (>= 4.1.16), file (>= 3.28-1), libncurses5-dev (>= 5.0-6), perl (>= 5.6.0), libwrap0-dev (>= 7.6-8.3), zlib1g-dev (>= 1:1.1.3-5), libreadline5-dev | libreadline-dev, psmisc, po-debconf, chrpath, automake1.9, doxygen, gs, dpatch, gawk, bison, lsb-release, fakeroot
 Standards-Version: 3.8.0
-Homepage: http://www.percona.com/
-Vcs-Browser: http://bazaar.launchpad.net/~percona-dev/percona-server/release-5.1.47-11/files
-Vcs-Bzr: bzr+ssh://bazaar.launchpad.net/~percona-dev/percona-server/release-5.1.47-11/
+Homepage: http://www.percona.com/software/
+Vcs-Browser: http://bazaar.launchpad.net/~percona-dev/percona-server/release-5.1.54-12/files
+Vcs-Bzr: bzr+ssh://bazaar.launchpad.net/~percona-dev/percona-server/release-5.1.54-12/
 
 Package: libmysqlclient16
 Section: libs

=== modified file 'build/debian/patches/00list'
--- build/debian/patches/00list	2010-11-29 11:14:04 +0000
+++ build/debian/patches/00list	2010-12-20 20:21:08 +0000
@@ -4,4 +4,3 @@
 44_scripts__mysql_config__libs.dpatch
 50_mysql-test__db_test.dpatch
 60_percona_support.dpatch
-70_handlersocket.dpatch

=== removed file 'build/debian/patches/70_handlersocket.dpatch'
--- build/debian/patches/70_handlersocket.dpatch	2010-11-29 11:14:04 +0000
+++ build/debian/patches/70_handlersocket.dpatch	1970-01-01 00:00:00 +0000
@@ -1,26 +0,0 @@
-#! /bin/sh /usr/share/dpatch/dpatch-run
-
-@DPATCH@
-
-diff -Nur a/storage/HandlerSocket-Plugin-for-MySQL/configure.ac b/storage/HandlerSocket-Plugin-for-MySQL/configure.ac
---- a/storage/HandlerSocket-Plugin-for-MySQL/configure.ac	2010-11-29 11:08:46.000000000 +0000
-+++ b/storage/HandlerSocket-Plugin-for-MySQL/configure.ac	2010-11-29 11:08:52.000000000 +0000
-@@ -79,14 +79,10 @@
-   AC_ARG_WITH([mysql-plugindir],
-     [AS_HELP_STRING([--with-mysql-plugindir=PATH], [MySQL plugin directory where handlersocket.so to be copied])],
-     [
--      ac_mysql_plugin_dir=`cd $withval && pwd`
--      if test -d "$ac_mysql_plugin_dir/" ; then
--        PLUGIN_DIR="$ac_mysql_plugin_dir"
--        AC_SUBST(PLUGIN_DIR)
--        AC_MSG_RESULT([yes: Using $ac_mysql_plugin_dir])
--      else
--        AC_MSG_ERROR([invalid MySQL plugin directory : $ac_mysql_plugin_dir])
--      fi
-+      ac_mysql_plugin_dir=`echo $withval`
-+      PLUGIN_DIR="$ac_mysql_plugin_dir"
-+      AC_SUBST(PLUGIN_DIR)
-+      AC_MSG_RESULT([yes: Using $ac_mysql_plugin_dir])
-     ],
-     [
-       LIB_DIR_TMP=`"$ac_mysql_config" --plugindir`

=== modified file 'build/debian/percona-server-server-5.1.postinst'
--- build/debian/percona-server-server-5.1.postinst	2010-05-31 13:57:21 +0000
+++ build/debian/percona-server-server-5.1.postinst	2010-12-20 20:03:55 +0000
@@ -237,6 +237,12 @@
     set +e
     echo "$install_plugins"                                  | $MYSQL_BOOTSTRAP 2>&1 | $ERR_LOGGER
     set -e
+    echo "Percona Server is distributed with several useful UDF (User Defined Function) from Maatkit"
+    echo "Run following command to create these functions:"
+    echo "mysql -e \"CREATE FUNCTION fnv1a_64 RETURNS INTEGER SONAME 'libfnv1a_udf.so'\""
+    echo "mysql -e \"CREATE FUNCTION fnv_64 RETURNS INTEGER SONAME 'libfnv_udf.so'\""
+    echo "mysql -e \"CREATE FUNCTION murmur_hash RETURNS INTEGER SONAME 'libmurmur_udf.so'\""
+    echo "See http://code.google.com/p/maatkit/source/browse/trunk/udf for more details"
   ;;
 
   abort-upgrade|abort-remove|abort-configure)

=== modified file 'build/debian/rules'
--- build/debian/rules	2010-11-29 11:14:04 +0000
+++ build/debian/rules	2010-12-20 21:54:44 +0000
@@ -9,7 +9,7 @@
 TMP=$(CURDIR)/debian/tmp/
 
 major_version_default=12
-minor_version_default=3
+minor_version_default=5
 
 ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 ARCH_OS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
@@ -187,6 +187,7 @@
 
 	# make install (trailing slash needed for innobase)
 	$(MAKE) install DESTDIR=$(TMP)/
+	# build HandlerSockect
 	cd storage/HandlerSocket-Plugin-for-MySQL && \
 	./autogen.sh && \
 	CXX=g++ ./configure --with-mysql-source="$(MYSQL_SRC)" \
@@ -196,6 +197,8 @@
 	--prefix="/usr" && \
 	$(MAKE)
 	cd storage/HandlerSocket-Plugin-for-MySQL && $(MAKE) install DESTDIR=$(TMP)/
+	# build Maatkit UDF
+	cd UDF/ && CXX=g++ ./configure --includedir=$(MYSQL_SRC)/include --libdir=/usr/lib/mysql/plugin && $(MAKE) all && $(MAKE) install DESTDIR=$(TMP)/
 		
 	# After installing, remove rpath to make lintian happy.
 	set +e; \

=== modified file 'build/percona-server.spec'
--- build/percona-server.spec	2010-12-02 17:11:35 +0000
+++ build/percona-server.spec	2010-12-20 21:54:44 +0000
@@ -14,9 +14,9 @@
 %define mysql_vendor  Percona, Inc
 %define redhatversion %(lsb_release -rs | awk -F. '{ print $1}')
 %define community 1
-%define mysqlversion 5.1.52
+%define mysqlversion 5.1.54
 %define majorversion 12
-%define minorversion 3
+%define minorversion 5
 %define distribution  rhel%{redhatversion}
 %define release       rel%{majorversion}.%{minorversion}.%{gotrevision}.%{distribution}
 
@@ -321,6 +321,14 @@
 	--libdir=%{_libdir} \
 	--prefix=%{_prefix}
 make
+cd -
+}
+
+BuildUDF() {
+cd UDF
+CXX=g++ ./configure --includedir=$RPM_BUILD_DIR/%{src_dir}/include --libdir=%{_libdir}/mysql/plugin
+make all
+cd -
 }
 # end of function definition "BuildHandlerSocket"
 
@@ -411,6 +419,7 @@
 
 BuildServer
 BuildHandlerSocket
+BuildUDF
 if [ "$MYSQL_RPMBUILD_TEST" != "no" ] ; then
 	MTR_BUILD_THREAD=auto make %{NORMAL_TEST_MODE}
 fi
@@ -443,6 +452,10 @@
 make DESTDIR=$RBR benchdir_root=%{_datadir} install
 cd storage/HandlerSocket-Plugin-for-MySQL
 make DESTDIR=$RBR benchdir_root=%{_datadir} install
+cd -
+cd UDF
+make DESTDIR=$RBR benchdir_root=%{_datadir} install
+cd -
 
 # install symbol files ( for stack trace resolution)
 #install -m644 $MBD/sql/mysqld.sym $RBR%{_libdir}/mysql/mysqld.sym
@@ -470,7 +483,6 @@
 install -m600 $MBD/support-files/RHEL4-SElinux/mysql.{fc,te} \
 	$RBR%{_datadir}/mysql/SELinux/RHEL4
 
-
 ##############################################################################
 #  Post processing actions, i.e. when installed
 ##############################################################################
@@ -646,6 +658,13 @@
 	sleep 2
 fi
 
+echo "Percona Server is distributed with several useful UDF (User Defined Function) from Maatkit"
+echo "Run following command to create these functions:"
+echo "mysql -e \"CREATE FUNCTION fnv1a_64 RETURNS INTEGER SONAME 'libfnv1a_udf.so'\""
+echo "mysql -e \"CREATE FUNCTION fnv_64 RETURNS INTEGER SONAME 'libfnv_udf.so'\""
+echo "mysql -e \"CREATE FUNCTION murmur_hash RETURNS INTEGER SONAME 'libmurmur_udf.so'\""
+echo "See http://code.google.com/p/maatkit/source/browse/trunk/udf for more details"
+
 # Allow mysqld_safe to start mysqld and print a message before we exit
 sleep 2
 
@@ -681,7 +700,6 @@
 %doc support-files/my-*.cnf
 
 %doc %attr(644, root, root) %{_infodir}/mysql.info*
-
 %doc %attr(644, root, man) %{_mandir}/man1/innochecksum.1*
 %doc %attr(644, root, man) %{_mandir}/man1/my_print_defaults.1*
 %doc %attr(644, root, man) %{_mandir}/man1/myisam_ftdump.1*
@@ -827,6 +845,14 @@
 %defattr(-, root, root, 0755)
 # Shared libraries (omit for architectures that don't support them)
 %{_libdir}/*.so*
+# Maatkit UDF libs
+%{_libdir}/mysql/plugin/libfnv1a_udf.a
+%{_libdir}/mysql/plugin/libfnv1a_udf.la
+%{_libdir}/mysql/plugin/libfnv_udf.a
+%{_libdir}/mysql/plugin/libfnv_udf.la
+%{_libdir}/mysql/plugin/libmurmur_udf.a
+%{_libdir}/mysql/plugin/libmurmur_udf.la
+
 %{_libdir}/mysql/*.so*
 
 

=== modified file 'fix-bug671764.patch'
--- fix-bug671764.patch	2010-12-17 19:06:49 +0000
+++ fix-bug671764.patch	2010-12-20 21:54:44 +0000
@@ -1,19 +1,21 @@
-#
-#
-#
-#
-#
-#
-diff -ruN a/configure.in b/configure.in
-diff -ruN a/configure.in b/configure.in
+diff -Nur a/configure.in b/configure.in
 --- a/configure.in	2010-11-29 18:45:47.000000000 +0000
 +++ b/configure.in	2010-11-29 18:45:51.000000000 +0000
-@@ -2797,7 +2797,7 @@
+@@ -2737,7 +2737,7 @@
+     MAN_DROP="$MAN_DROP embedded"
+     grep -v 'embedded' $MANLISTFIL > $TMPLISTFIL ; mv -f $TMPLISTFIL $MANLISTFIL
+   fi
+-  if test X"$with_plugin_innobase" != Xyes
++  if test X"$with_plugin_innodb_plugin" != Xyes
+   then
+     MAN_DROP="$MAN_DROP innodb"
+     grep -v 'inno' $MANLISTFIL > $TMPLISTFIL ; mv -f $TMPLISTFIL $MANLISTFIL
+@@ -2816,7 +2816,7 @@
  fi
- 
+
  # "innochecksum" is not in the "innobase/" subdirectory, but should be switched
 -AM_CONDITIONAL([BUILD_INNODB_TOOLS], [test X"$with_plugin_innobase" = Xyes])
 +AM_CONDITIONAL([BUILD_INNODB_TOOLS], [test X"$with_plugin_innodb_plugin" = Xyes])
- 
+
  # IMPORTANT - do not modify LIBS past this line - this hack is the only way
  # I know to add the static NSS magic if we have static NSS libraries with

=== added file 'handlersocket.patch'
--- handlersocket.patch	1970-01-01 00:00:00 +0000
+++ handlersocket.patch	2010-12-17 17:07:17 +0000
@@ -0,0 +1,22 @@
+diff -Nur configure.ac.orig configure.ac
+--- configure.ac.orig	2010-11-29 11:08:46.000000000 +0000
++++ configure.ac	2010-11-29 11:08:52.000000000 +0000
+@@ -79,14 +79,10 @@
+   AC_ARG_WITH([mysql-plugindir],
+     [AS_HELP_STRING([--with-mysql-plugindir=PATH], [MySQL plugin directory where handlersocket.so to be copied])],
+     [
+-      ac_mysql_plugin_dir=`cd $withval && pwd`
+-      if test -d "$ac_mysql_plugin_dir/" ; then
+-        PLUGIN_DIR="$ac_mysql_plugin_dir"
+-        AC_SUBST(PLUGIN_DIR)
+-        AC_MSG_RESULT([yes: Using $ac_mysql_plugin_dir])
+-      else
+-        AC_MSG_ERROR([invalid MySQL plugin directory : $ac_mysql_plugin_dir])
+-      fi
++      ac_mysql_plugin_dir=`echo $withval`
++      PLUGIN_DIR="$ac_mysql_plugin_dir"
++      AC_SUBST(PLUGIN_DIR)
++      AC_MSG_RESULT([yes: Using $ac_mysql_plugin_dir])
+     ],
+     [
+       LIB_DIR_TMP=`"$ac_mysql_config" --plugindir`

=== modified file 'innodb_fix_misc.patch'
--- innodb_fix_misc.patch	2010-12-16 11:35:26 +0000
+++ innodb_fix_misc.patch	2010-12-20 21:54:44 +0000
@@ -25,7 +25,7 @@
  #define INNODB_VERSION_BUGFIX	14
  
 +#ifndef PERCONA_INNODB_VERSION
-+#define PERCONA_INNODB_VERSION 12.4
++#define PERCONA_INNODB_VERSION 12.5
 +#endif
 +
 +

=== modified file 'percona-support.patch'
--- percona-support.patch	2010-10-19 00:20:32 +0000
+++ percona-support.patch	2010-12-20 18:38:48 +0000
@@ -17,3 +17,15 @@
  fi
 
  exit 0
+diff -Nur a/support-files/mysql.server.sh b/support-files/mysql.server.sh
+--- a/support-files/mysql.server.sh	2010-12-20 18:15:26.000000000 +0000
++++ b/support-files/mysql.server.sh	2010-12-20 18:24:53.000000000 +0000
+@@ -300,7 +300,7 @@
+       manager=$sbindir/mysqlmanager
+     fi
+ 
+-    echo $echo_n "Starting MySQL"
++    echo $echo_n "Starting MySQL (Percona Server)"
+     if test -x $manager -a "$use_mysqld_safe" = "0"
+     then
+       if test -n "$other_args"

